--AH:ScriptId=114ded20-7d2e-4a7f-98c5-24f2448904a3;3121

CREATE TABLE [IssueSources]
(
    [IssueSource_Id] INT IDENTITY(1,1) NOT NULL,
    [IssueSource_Name] VARCHAR(255) NOT NULL,
    [Application_Id] INT NULL,
    [ApplicationGroup_Id] INT NULL,
    [IssueSource_Configuration] XML NOT NULL,
    [Last_Pull_Date] DATETIME NULL,
    [Last_Execution_Id] INT NULL
    
    CONSTRAINT [FK__IssueSources__Executions] 
    FOREIGN KEY([Last_Execution_Id])
    REFERENCES [Executions] ([Execution_Id])
    ON DELETE SET NULL,
    

    CONSTRAINT [PK__IssueSources] PRIMARY KEY ([IssueSource_Id]),
    CONSTRAINT [FK__IssueSources__Applications] FOREIGN KEY ([Application_Id]) 
               REFERENCES [Applications] ([Application_Id])
               ON DELETE CASCADE,
    CONSTRAINT [FK__IssueSources__ApplicationGroups] FOREIGN KEY ([ApplicationGroup_Id]) 
               REFERENCES [ApplicationGroups] ([ApplicationGroup_Id])
               ON DELETE CASCADE,
    CONSTRAINT [CK__IssueSources__Scope] CHECK ([Application_Id] IS NULL OR [ApplicationGroup_Id] IS NULL)
)