EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'AdminEdit_UpdatePromotionStatus',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Updates the status of a promotion.',
    /* Remarks_Text            */ NULL
GO

IF OBJECT_ID('[AdminEdit_UpdatePromotionStatus]') IS NOT NULL DROP PROCEDURE [AdminEdit_UpdatePromotionStatus]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [AdminEdit_UpdatePromotionStatus]
(
	@Promotion_Id INT,
    @PromotionStatus_Name VARCHAR(20)
)
AS
BEGIN

    SET NOCOUNT ON


BEGIN TRY
	BEGIN TRANSACTION

    IF EXISTS(SELECT * FROM [BuildPromotions]
               WHERE [Promotion_Id] = @Promotion_Id
                 AND [PromotionStatus_Name] = @PromotionStatus_Name)
    BEGIN
        ROLLBACK
        RETURN
    END


    UPDATE [BuildPromotions]
       SET [PromotionStatus_Name] = @PromotionStatus_Name,
           [StatusOverriddenBy_User_Name] = [dbo].Session_GetUserName(),
           [StatusOverridden_Date] = GETUTCDATE(),
           [StatusOverriddenReason_Text] = 'Overridden via Administrative Edit'
     WHERE [Promotion_Id] = @Promotion_Id

    COMMIT

END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [AdminEdit_UpdatePromotionStatus] TO [BuildMasterUser_Role]
