EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'EventListeners_GetEventListeners',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataSet',
    /* DataTableNames_Csv      */ 'EventListeners,EventListenerApplications,EventListenerApplicationGroups,EventListenerStages,EventListenerEvents',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets a list of event listeners for the specified user, or all users if no user is specified.'
GO

IF OBJECT_ID('[EventListeners_GetEventListeners]') IS NOT NULL DROP PROCEDURE [EventListeners_GetEventListeners]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [EventListeners_GetEventListeners]
(
	@Owner_User_Name USERNAME = NULL
)
AS
BEGIN

SET NOCOUNT ON

	DECLARE @IDS TABLE ([Id] INT)
	
	INSERT INTO @IDS
	SELECT [EventListener_Id] FROM [EventListeners] 
	 WHERE [Owner_User_Name] = COALESCE(@Owner_User_Name,[Owner_User_Name]) OR (@Owner_User_Name IS NULL AND [Owner_User_Name] IS NULL)

	SELECT * FROM [EventListeners] WHERE [EventListener_Id] IN (SELECT [Id] FROM @IDS)
	SELECT * FROM [EventListenerApplications] WHERE [EventListener_Id] IN (SELECT [Id] FROM @IDS)
	SELECT * FROM [EventListenerApplicationGroups] WHERE [EventListener_Id] IN (SELECT [Id] FROM @IDS)
	SELECT * FROM [EventListenerStages] WHERE [EventListener_Id] IN (SELECT [Id] FROM @IDS)
	SELECT * FROM [EventListenerEvents] WHERE [EventListener_Id] IN (SELECT [Id] FROM @IDS)

END
GO

GRANT EXECUTE ON [EventListeners_GetEventListeners] TO [BuildMasterUser_Role]
