EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Executions_CreateBuildTriggerExecution',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ 'Execution_Id',
    /* Description_Text        */ 'Creates a build trigger execution.'
GO

IF OBJECT_ID('[Executions_CreateBuildTriggerExecution]') IS NOT NULL DROP PROCEDURE [Executions_CreateBuildTriggerExecution]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Executions_CreateBuildTriggerExecution]
(
	@Plan_Name VARCHAR(255),
	@Application_Id INT,
	@RepositoryMonitor_Id INT = NULL,
	@Webhook_Id INT = NULL,
	@Execution_Id INT = NULL OUT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	INSERT INTO [Executions]
	(
		[Start_Date],
		[ExecutionStatus_Code],
		[ExecutionRunState_Code],
		[ExecutionMode_Code],
		[CreatedBy_User_Name],
		[CreatedOn_Date]
	)
	VALUES
	(
		GETUTCDATE(),
		'S',
		'P',
		'T',
		dbo.Session_GetUserName(),
		GETUTCDATE()
	)

	SET @Execution_Id = SCOPE_IDENTITY()

	INSERT INTO [BuildTriggerExecutions]
	(
		[Execution_Id],
		[Plan_Name],
		[Application_Id],
		[RepositoryMonitor_Id],
		[Webhook_Id]
	)
	VALUES
	(
		@Execution_Id,
		@Plan_Name,
		@Application_Id,
		@RepositoryMonitor_Id,
		@Webhook_Id
	)

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH
END
GO

GRANT EXECUTE ON [Executions_CreateBuildTriggerExecution] TO [BuildMasterUser_Role]
