EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Executions_GetExecutionsToExecuteOrCancel',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'Executions_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Returns executions which are ready to be started by the executer or are ready for cancellation.'
GO

IF OBJECT_ID('[Executions_GetExecutionsToExecuteOrCancel]') IS NOT NULL DROP PROCEDURE [Executions_GetExecutionsToExecuteOrCancel]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Executions_GetExecutionsToExecuteOrCancel]
AS
BEGIN

	SET NOCOUNT ON

	SELECT *
	  FROM [Executions_Extended]
	 WHERE ([ExecutionRunState_Code] = 'P' AND ([Start_Date] < GETUTCDATE() OR [CanceledOn_Date] IS NOT NULL))
	    OR ([ExecutionRunState_Code] = 'X' AND [CanceledOn_Date] IS NOT NULL)

END
GO

GRANT EXECUTE ON [Executions_GetExecutionsToExecuteOrCancel] TO [BuildMasterUser_Role]
GO