EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'ServerRoles_GetServerRolesEnvironments',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'ServerRolesEnvironments_Merged',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets all the server role and environment relations that match the specified criteria.'
GO


IF OBJECT_ID('[ServerRoles_GetServerRolesEnvironments]') IS NOT NULL DROP PROCEDURE [ServerRoles_GetServerRolesEnvironments]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [ServerRoles_GetServerRolesEnvironments]
(
    @Environment_Id INT = NULL,
    @ServerRole_Id INT = NULL
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT * 
	  FROM [ServerRolesEnvironments_Merged]
     WHERE (@Environment_Id IS NULL OR [Environment_Id] = @Environment_Id)
       AND (@ServerRole_Id IS NULL OR [ServerRole_Id] = @ServerRole_Id)

END
GO

GRANT EXECUTE ON [ServerRoles_GetServerRolesEnvironments] TO [BuildMasterUser_Role]