EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Servers_DeleteServer',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Deletes a server.'
GO


IF OBJECT_ID('[Servers_DeleteServer]') IS NOT NULL DROP PROCEDURE [Servers_DeleteServer]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Servers_DeleteServer]
(
	@Server_Id INT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	DECLARE @Server_Name SQL_VARIANT
	    SET @Server_Name = (SELECT [Server_Name] FROM [Servers] WHERE [Server_Id] = @Server_Id)

	DELETE [EnvironmentServers]
	 WHERE [Server_Id] = @Server_Id

	UPDATE [ConfigurationFileDeployments]
	   SET [Server_Id] = NULL
	 WHERE [Server_Id] = @Server_Id

	DELETE [Servers]
	 WHERE [Server_Id] = @Server_Id

	IF @@ROWCOUNT>0
	EXEC [Events_RaiseEvent] 'ENVDLS', NULL, @Server_Name

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Servers_DeleteServer] TO [BuildMasterUser_Role]