EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Servers_GetServerLogs',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'LogMessages_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the logs associated with the specified server.'
GO


IF OBJECT_ID('[Servers_GetServerLogs]') IS NOT NULL DROP PROCEDURE [Servers_GetServerLogs]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Servers_GetServerLogs]
(
    @Server_Id INT,
	@LogMessage_Count INT = NULL
)
AS
BEGIN

	SET NOCOUNT ON

	IF @LogMessage_Count IS NOT NULL
		SET ROWCOUNT @LogMessage_Count

	SELECT *
	  FROM [LogMessages_Extended]
	 WHERE [Server_Id] = @Server_Id
  ORDER BY [Logged_Date] DESC

END
GO

GRANT EXECUTE ON [Servers_GetServerLogs] TO [BuildMasterUser_Role]